"""Metrics for probabilistic supervised regression."""
# copyright: skpro developers, BSD-3-Clause License (see LICENSE file)
# adapted from sktime

__author__ = ["fkiraly", "euanenticott-shell"]

__all__ = [
    "PinballLoss",
    "EmpiricalCoverage",
    "ConstraintViolation",
    "CRPS",
    "LogLoss",
    "LinearizedLogLoss",
    "SquaredDistrLoss",
]

from skpro.metrics._classes import (
    CRPS,
    ConstraintViolation,
    EmpiricalCoverage,
    LinearizedLogLoss,
    LogLoss,
    PinballLoss,
    SquaredDistrLoss,
)
